// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { LogError } from "../../../../core/decorator/LogErrorDecorator";
import { AddAgentRequest, RemoveAgentRequest } from "../../request";
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import { RemoveAgentCommand } from "../../../../app/usecase/command/security/operations/agent/removeAgent/RemoveAgentCommand";
import { AddAgentCommand } from "../../../../app/usecase/command/security/operations/agent/addAgent/AddAgentCommand";
import { BaseSecurityInPort } from "../BaseSecurityInPort";
export class SecurityInPortAgent extends BaseSecurityInPort {
    async addAgent(request) {
        ValidatedRequest.handleValidation(AddAgentRequest.name, request);
        return await this.commandBus.execute(new AddAgentCommand(request.securityId, request.agentId));
    }
    async removeAgent(request) {
        ValidatedRequest.handleValidation(RemoveAgentRequest.name, request);
        return await this.commandBus.execute(new RemoveAgentCommand(request.securityId, request.agentId));
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [AddAgentRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortAgent.prototype, "addAgent", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [RemoveAgentRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortAgent.prototype, "removeAgent", null);
